updated documentation for previous patch
[grml-crypt.git] / grml-crypt
1 #!/bin/bash
2 # Filename:      grml-crypt
3 # Purpose:       Program to format, mount and unmount encrypted devices/files
4 # Authors:       Michael Gebetsroither <gebi@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Don Jul 26 19:57:28 CEST 2007 [mika]
8 ################################################################################
9
10
11 ###
12 ### __INCLUDES
13 ###
14 . /etc/grml/sh-lib
15 #. /etc/grml/sysexits-sh
16
17
18
19 ###
20 ### __VARIABLES
21 ###
22
23 verbose_=0
24 DEV_MAPPER_="/dev/mapper"
25 CRYPTSETUP_="cryptsetup"
26 IS_IMAGE_='false'
27 SIZE_="10"
28 SIZE_SET_='false'
29 FSTYPE_="vfat"
30 TARGET_=""
31 VERIFY_PW_=""
32 MKFS_=""
33 DM_NAME_=""
34 DM_PATH_=""
35 ACTION_=""
36 DM_PREFIX_="grml-crypt_"
37 FORCE_='false'
38 FSCK_='false'
39 ENTROPY_SOURCE_='/dev/urandom'
40 OPTIMIZED_MODE_SET_='false'
41 OPTIMIZING_LEVEL_=0
42 CIPHER_SIZE_="256"
43 CIPHER_="aes-cbc-essiv:sha256"
44 ITERATION_TIME_="1000"
45 ADDITIONAL_CRYPTSETUP_ARGS_=""
46 READONLY_SET_='false'
47 ADDITIONAL_MOUNT_ARGS_=""
48 BATCH_MODE_="--batch-mode"
49 PV_='/usr/bin/pv'
50
51 ###
52 ### __FUNCTIONS
53 ###
54
55 function printUsage
56 {
57   cat <<EOT
58 Usage: "$PROG_NAME__" [OPTIONS] action <device/file> [mountpoint]
59
60 $PROG_NAME__ is a wrapper around cryptsetup with LUKS support to format a device
61
62 OPTIONS:
63    -s         size of the loop-filesystem to create, in MB (default=$SIZE_)
64    -t         type of filesystem (default=$FSTYPE_)
65    -r         read only mode (fully supported only by start)
66    -z         insecure mode, using /dev/zero for most of the initialisation (INSECURE!)
67    -o         optimised initialisation mode (should be as secure as the default but faster)
68    -y         verifies the passphrase by asking for it twice
69    -f         force file overwriting in format mode and/or disable confirmation dialog
70    -F         only for action start: run fsck before mounting the filesystem. Use fsck's -f option if given twice.
71    -m         additional arguments to mount
72    -v         verbose (show what is going on, v++)
73    -h         this help text
74
75 CRYPTSETUP FORMAT OPTIONS:
76    -S         cipher size, could be 128, 192 or 256 (default=$CIPHER_SIZE_)
77    -C         cipher, should be aes-plain for pre-2.6.10 (default=$CIPHER_)
78    -I         iteration time spend with PBKDF2 password  processing in seconds (default=$ITERATION_TIME_)
79    -A         additional arguments for cryptsetup (only supportet by format)
80
81 ACTIONS:
82    format  <device/file> [mountpoint]
83               Format a device or a file (is created with the given size if it
84               does not exist) with the given filesystem and mount it, if a
85               mountpoint was given.
86    start  <device/file> [mountpoint]
87               Mount the device/file in the mountpoint or to a default mountpoint.
88    stop   <mountpoint>
89               Umount the given mountpoint (umount, luksClose, losetup -d)
90
91 EOT
92
93   isGrml && cat <<EOT
94 NOTICE:
95    losetup does _NOT_ work on unionfs => grml-crypt with a filesystem image does ONLY
96    work if the image is on a tmpfs (eg. in /home/grml or /tmp).
97
98 EOT
99
100 }
101
102
103 function getDMName
104 {
105   device_="${1##*/}"
106
107   # first trying normal devicename
108   tmp_="${DM_PREFIX_}${device_}"
109   if [ ! -e "$tmp_" ]; then
110     echo "$tmp_"
111     return 0
112   fi
113
114   # second trying uuid of luks
115   #uuid_=`execute "$CRYPTSETUP_ luksUUID $1"`
116   #if [[ $? == 0 ]]; then
117   #  echo "$prefix_$uuid_"
118   #  return 0
119   #fi
120   warn "could not create device-mapper name for $1"
121   return 1
122 }
123
124
125 function formatDevice
126 {
127   type_="$1"  # could be donothing or init
128   ret_=0
129   local ddcmd_="dd if=/dev/zero of=$DM_PATH_ bs=1M &>/dev/null"
130   if [[ -x "$PV_" && $verbose_ -ge 3 ]] ; then
131     ddcmd_="dd if=/dev/zero bs=1M 2>/dev/null | $PV_ | dd of=$DM_PATH_ bs=1M &>/dev/null"
132   fi
133
134   args_="$VERIFY_PW_ $BATCH_MODE_ --key-size $CIPHER_SIZE_ --cipher $CIPHER_ --iter-time $ITERATION_TIME_ $ADDITIONAL_CRYPTSETUP_ARGS_"
135   #args_=`echo "$args_" |tr -s ' '`
136   execute "$CRYPTSETUP_ $args_ luksFormat $TARGET_" warn || return 1
137
138   execute "$CRYPTSETUP_ luksOpen $TARGET_ $DM_NAME_" warn \
139     "could not open $DM_PATH_ to create a filesystem on it!" || return 1
140   if [[ $type_ == 'init' && $OPTIMIZED_MODE_SET_ == 'true' ]]; then
141     echo "finishing optimised initialisation (this could take some time)"
142     # FIXME
143     execute "$ddcmd_" # || \
144     #  warn "could not finish optimised initialisation properly"
145     ret_=$?
146     # cutted out because of no space left on device error :(
147     #if [[ $ret_ != 0 ]]; then
148     #  execute "$CRYPTSETUP_ luksClose $DM_NAME_" warn
149     #  return 1
150     #fi
151   fi
152
153   execute "$MKFS_ $DM_PATH_ >/dev/null" warn
154   if [[ $? != 0 ]]; then
155     execute "$CRYPTSETUP_ luksClose $DM_NAME_"
156     warn "could not create filesystem on $DM_PATH_" 1
157     return 1
158   else
159     echo "Successully created $FSTYPE_ on encrypted $TARGET_"
160     return 0
161   fi
162 }
163
164
165 function actionStart
166 {
167   ret_=0
168
169   if [[ "$MOUNT_POINT_" == "" ]]; then
170     MOUNT_POINT_="/mnt/$DM_NAME_"
171   else
172     # error out if mountpoint was given but doesn't exist
173     if [ ! -d "$MOUNT_POINT_" ]; then
174       die "mountpoint $MOUNT_POINT_ does not exist"
175     fi
176   fi
177   # removed due to unionfs problem isLuks does not work with filesystem images
178   # without losetup
179   #$CRYPTSETUP_ isLuks $TARGET_ || die "$TARGET_ is not a luks partition"
180
181   # TARGET (is/should be) a filesystem image
182   if [ ! -b "$TARGET_" ]; then
183     notice "Operating on a file"
184     isExistent "$TARGET_" die "image does not exist"
185     TARGET_=`findNextFreeLoop` || die "could not find a free loop device"
186
187     # TARGET_ is now /dev/loop<x>
188     execute "losetup $TARGET_ $ORIG_TARGET_" die
189   fi
190   cargs_=""
191   $READONLY_SET_ && cargs_='--readonly'
192   execute "$CRYPTSETUP_ $cargs_ luksOpen $TARGET_ $DM_NAME_" warn || execute "losetup -d $TARGET_" || \
193     die "could not luksOpen $TARGET_"
194   if [[ "$FSCK_" == "true" ]] ; then
195     execute "fsck -C $DM_PATH_" || die "fsck failed on $DM_PATH_"
196   elif [[ "$FSCK_" == "trueforce" ]] ; then
197     execute "fsck -f -C $DM_PATH_" || die "fsck failed on $DM_PATH_"
198   fi
199   margs_=""
200   $READONLY_SET_ && margs_='-r'
201   # mountpoint was not given so we use the default one which we need to create first
202   if [ ! -d "$MOUNT_POINT_" ]; then
203     execute "mkdir -p '$MOUNT_POINT_'" || die "failed to create mountpoint $MOUNT_POINT_"
204   fi
205   execute "mount $margs_ $ADDITIONAL_MOUNT_ARGS_ $DM_PATH_ $MOUNT_POINT_" die
206 }
207
208
209 function actionStop
210 {
211   mp_="$1"
212   ret_=0
213
214   isExistent "$mp_" die
215   tmp_=`realpath $mp_` || die "could not get realpath of $mp_"
216   dprint "realpath_=\"$tmp_\""
217
218   dm_path_=`mount |grep "$tmp_ "` || die "$tmp_ is not mounted"
219   dprint "dm_path_=\"$dm_path_\""
220   dm_path_=`echo $dm_path_ |awk '{print $1}'` || die "could not get devicemapper name for $tmp_"
221   dprint "dm_path_=\"$dm_path_\""
222
223   # check for symlinks
224   unset tmp_dm_path_
225   for dmapper in /dev/mapper/grml-crypt* ; do
226     link=$(readlink -f "$dmapper")
227     dprint "looping device mapper devices, dmapper=$dmapper => link=$link"
228     if [ "$link" = "$dm_path_" ] ; then
229       tmp_dm_path_="$dmapper"
230     fi
231   done
232
233   if [ -n "$tmp_dm_path_" ] ; then
234     dm_path_="$tmp_dm_path_"
235     unset tmp_dm_path_
236   fi
237
238   dm_name_="${dm_path_##*/}"
239   dprint "dm_name_=\"$dm_name_\""
240
241   dmsetup info $dm_name_ >/dev/null ||die "$dm_name_ is not active"
242   device_=`$CRYPTSETUP_ status $dm_name_ |awk '/device:/{print $2}'` || \
243     die "could not get underlying device of $dm_path_"
244   dprint "device_=\"$device_\""
245
246   execute "umount $dm_path_" die "could not unmount $device_"
247   if [[ "$MOUNT_POINT_" == "/mnt/$dm_name_" ]]; then
248     rmdir "$MOUNT_POINT_"
249   fi
250   execute "$CRYPTSETUP_ luksClose $dm_name_" die "could not close $dm_path_"
251   echo "$device_" |grep loop &>/dev/null && execute "losetup -d $device_" \
252     die "could not delete loop device $device_" || \
253     execute "losetup -d $device_ &>/dev/null" eprint "could not delete loop device $device_, \
254 this device possibly is not a loop device => maybe bogus error"
255   notice "$mp_ successfully unmountet/closed/deleted"
256 }
257
258 function yesDialog
259 {
260   msg_="$1"
261
262   echo "WARNING!" >&2
263   echo "========" >&2
264   echo -n "$msg_" >&2
265   echo -n " (type uppercase yes): " >&2
266   read input
267   if [[ $input == 'YES' ]]; then
268     return 0
269   fi
270
271   return 1
272 }
273
274 function actionFormat
275 {
276   IS_IMAGE_='false'
277   ret_=0
278   init_='init'
279   local ddcmd_
280
281   if (( $SIZE_ < 3 )); then
282     die "the minimum size of an encrypted luks partition should be 2"
283   fi
284
285   # TARGET (is/should be) a filesystem image
286   if [ ! -b "$TARGET_" ]; then
287     notice "Operating on a file"
288     IS_IMAGE_='true'
289     if [ -e "$TARGET_" ]; then
290       $FORCE_ || die "$TARGET_ does already exist"
291       warn "overwriting file $TARGET_"
292       init_='donothing'
293     else
294       echo -n "Initialising file with "
295       if [[ $OPTIMIZED_MODE_SET_ == 'true' ]]; then
296         echo "optimised SECURE mode"
297         execute "dd if=/dev/zero of=$TARGET_ bs=1M count=${SIZE_} &>/dev/null" \
298           die "could not initialise $TARGET_ with /dev/zero"
299       else
300         if [[ $ENTROPY_SOURCE_ == '/dev/zero' ]]; then
301           echo "INSERCURE mode"
302         else
303           echo "SECURE mode (taking /dev/urandom as source, this could take some time)"
304         fi
305         execute "dd if=$ENTROPY_SOURCE_ of=$TARGET_ bs=1M count=${SIZE_} &>/dev/null" ||\
306           die "could not initialise $TARGET_ with $ENTROPY_SOURCE_"
307       fi
308     fi
309
310     TARGET_=`findNextFreeLoop` || die "could not find a free loop device"
311
312     # TARGET_ is now /dev/loop<x>
313     execute "losetup $TARGET_ $ORIG_TARGET_" die
314     if [[ $OPTIMIZED_MODE_SET_ == 'true' || $ENTROPY_SOURCE_ == '/dev/zero' ]]; then
315       execute "dd if=/dev/urandom of=$TARGET_ bs=1M count=2 &>/dev/null" \
316       die "could not initialise the fist 2MB of $TARGET_ with /dev/urandom"
317     fi
318     formatDevice "$init_"
319     ret_=$?
320   else
321     $FORCE_ || (yesDialog "Are you shure you want to overwrite $TARGET_ ?" || die 'You are not sure')
322     notice 'Operating on a device'
323     echo -n 'Initialising device with '
324     if [[ $OPTIMIZED_MODE_SET_ == 'true' ]]; then
325       echo "optimised SECURE mode"
326       execute "dd if=/dev/urandom of=$TARGET_ bs=1M count=2 &>/dev/null" ||\
327         die "could not initialise the first 2MB of $TARGET_ with /dev/urandom"
328     elif [[ $ENTROPY_SOURCE_ != '/dev/zero' ]]; then
329       # default mode
330       echo "SECURE mode (taking $ENTROPY_SOURCE_ as source, this could take some time)"
331       ddcmd_="dd if=$ENTROPY_SOURCE_ of=$TARGET_ bs=1M &>/dev/null"
332       if [[ -x "$PV_" && $verbose_ -ge 3 ]] ; then
333         ddcmd_="dd if=$ENTROPY_SOURCE_ bs=1M 2>/dev/null | $PV_ | dd of=$TARGET_ bs=1M &>/dev/null"
334       fi
335       execute "$ddcmd_" # ||\
336         # skipped because "no space left on device" from dd
337         # die "could not initialise $TARGET_ with $ENTROPY_SOURCE_"
338     else
339       echo 'INSECURE mode (only initialising the fist 2MB with /dev/urandom)'
340       execute "dd if=/dev/urandom of=$TARGET_ bs=1M count=2 &>/dev/null" \
341         die "could not initialise the first 2MB of $TARGET_ with /dev/urandom"
342     fi
343
344     formatDevice "$init_"
345     ret_=$?
346   fi
347
348   # formatDevice was successfully
349   if (( $ret_ == 0 )); then
350     # a mountpoint was given (don't luksClose the device)
351     local mount_point_exists_='true'
352     test -d "$MOUNT_POINT_" || mount_point_exists_='false'
353
354     if [[ $MOUNT_POINT_ != "" && "$mount_point_exists_" == 'true' ]]; then
355       $READONLY_SET_ && margs_='-r'
356       execute "mount $margs_ $ADDITIONAL_MOUNT_ARGS_ $DM_PATH_ $MOUNT_POINT_" die
357     else
358       if [[ $MOUNT_POINT_ != "" ]]; then
359         $mount_point_exists_ || warn "mountpoint $MOUNT_POINT_ does not exist, not mounting. please use \"grml-crypt start $ORIG_TARGET_ <mountpoint>\" to start the device"
360       fi
361       execute "$CRYPTSETUP_ luksClose $DM_NAME_" warn
362       $IS_IMAGE_ && execute "losetup -d $TARGET_" warn
363     fi
364   else
365     execute "$CRYPTSETUP_ luksClose $DM_NAME_" warn
366     $IS_IMAGE_ && execute "losetup -d $TARGET_" warn
367   fi
368 }
369
370
371
372 ###
373 ### __MAIN
374 ###
375
376 while getopts "s:t:rzoyfFm:hvS:C:I:A:" opt; do
377   case "$opt" in
378     s) SIZE_="$OPTARG"; SIZE_SET_='true' ;;
379     t) FSTYPE_="$OPTARG" ;;
380     r) READONLY_SET_='true' ;;
381     z) let OPTIMIZING_LEVEL_=$OPTIMIZING_LEVEL_+1
382         ENTROPY_SOURCE_='/dev/zero'
383         warn 'initialising from INSECURE source /dev/zero' ;;
384     o) let OPTIMIZING_LEVEL_=$OPTIMIZING_LEVEL_+1
385         OPTIMIZED_MODE_SET_='true' ;;
386     y) VERIFY_PW_="--verify-passphrase" ;;
387     f) FORCE_='true' ;;
388     F) if [[ "$FSCK_" == "true" ]] ; then
389          FSCK_='trueforce'
390        else
391          FSCK_='true'
392        fi
393       ;;
394     m) ADDITIONAL_MOUNT_ARGS_="$OPTARG" ;;
395     h) printUsage; exit ;;
396     v) let verbose_=$verbose_+1 ;;
397     S) CIPHER_SIZE_="$OPTARG" ;;
398     C) CIPHER_="$OPTARG" ;;
399     I) ITERATION_TIME_="$OPTARG" ;;
400     A) ADDITIONAL_CRYPTSETUP_ARGS_="$OPTARG" ;;
401     ?) printUsage; exit 64 ;;
402   esac
403 done
404 shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
405 setVerbose $verbose_
406
407 checkRoot die "You have to be root to use this program"
408 disableSyslog
409
410 if [[ $1 == 'help' ]]; then
411   printUsage
412   exit 0
413 fi
414 if (( $# < 2 )); then
415   printUsage
416   die "wrong number of arguments ($#)" 1
417 fi
418 if (( $OPTIMIZING_LEVEL_ > 1 )); then
419   printUsage
420   die "please choose ONE initialisation methode"
421 fi
422 TARGET_="$2"
423
424 MKFS_="/sbin/mkfs.$FSTYPE_"
425 if [ ! -x "$MKFS_" ]; then
426   die "invalid filesystem type \"$FSTYPE_\"" 1
427 fi
428
429 # use batch-mode if available
430 $CRYPTSETUP_ $BATCH_MODE_ --help &>/dev/null;
431 ret_=$?
432 case "$ret_" in
433   0)  dprint "your cryptsetup understands --batch-mode" ;;
434   1)  BATCH_MODE_=""; notice "your cryptsetup does NOT understand --batch-mode, trying without" ;;
435   127)  die "could not execute cryptsetup" 127 ;;
436   *)  warn "problems executing $CRYPTSETUP_" $ret_
437 esac
438
439 DM_NAME_="`getDMName $TARGET_`"
440 DM_PATH_="$DEV_MAPPER_/$DM_NAME_"
441 ORIG_TARGET_="$TARGET_"
442 MOUNT_POINT_="$3"
443
444 case "$1" in
445   format) ACTION_='format'; actionFormat ;;
446   start)  ACTION_='start'; actionStart ;;
447   stop)  ACTION_='stop'; actionStop "$TARGET_" ;;
448   *)  printUsage ;;
449 esac
450
451 # END OF FILE
452 ################################################################################
453 # vim:foldmethod=marker tabstop=2 expandtab shiftwidth=2